
#include "bitstream.h"

namespace Huffman
{
    
    bitistream::bitistream(std::istream& is)
    {
        buffer = 0;
        bufferpos = -1; // buffer is empty
        backend = &is;
    }
    
    bitistream::~bitistream()
    {
    }
    
    bitistream& bitistream::operator>>(bool& value)
    {
        if(bufferpos < 0)
        {
            buffer = (unsigned char)backend->get();
            bufferpos = 7;
        }
        value = (buffer & (1<<bufferpos)) != 0;
        bufferpos--;
        return *this;
    }

    
    
    

    bitostream::bitostream(std::ostream& os)
    {
        backend = &os;
        buffer = 0;
        bufferpos = 0;
    }
    
    bitostream::~bitostream()
    {
    }
    
    void bitostream::flush()
    {
        if(bufferpos != 0)
        {
            while(bufferpos <= 7)
            {
                buffer *= 2;
                bufferpos++;
            }
            backend->put((unsigned char)(buffer));
            backend->flush();
            buffer = 0;
            bufferpos = 0;
        }
    }
    
    bitostream& bitostream::operator<<(bool value)
    {
        buffer = (buffer * 2) + value;
        bufferpos++;
        if(bufferpos > 7)
            flush();
        return *this;
    }

}